'use strict';

var path = require('path');
var requiredPath = require('required-path');

var strLang = function strLang(file, lang) {
    return '\nif (\n    process.env.BEM_LANG?\n        process.env.BEM_LANG === \'' + lang + '\' :\n        process.env.REACT_APP_BEM_LANG?\n            process.env.REACT_APP_BEM_LANG === \'' + lang + '\' :\n            \'en\' === \'' + lang + '\'\n) {\n    return core()\n        .decl(require(\'' + requiredPath(path.join(file.path, lang)) + '\'))\n        (\'' + file.cell.entity.id + '\');\n}\n';
};

var langEnvErr = function langEnvErr(env, langs) {
    return 'process.env.' + env + ' && ' + ('console.error(\'No match of process.env.' + env + ' { \' + process.env.' + env + ' + \' } in provided langs: { ' + langs.join(', ') + ' }\');');
};

var onlyDEV = function onlyDEV(strings) {
    return '\nif (process.env.NODE_ENV === \'development\') {\n    ' + strings.join('\n') + '\n}\n';
};

function generateI18n(langs, files) {

    return files.reduce(function (acc, file) {
        return acc.concat(langs.map(function (lang) {
            return strLang(file, lang);
        }));
    }, ['(function() {', 'var core = require(\'bem-i18n\');']).concat([onlyDEV([langEnvErr('BEM_LANG', langs), langEnvErr('REACT_APP_BEM_LANG', langs)]), 'return function(){};\n})()']).join('\n');
}

module.exports = {
    generate: function generate(langs) {
        return generateI18n.bind(null, langs);
    }
};